// Adafruit Feather nRF52 Bluefruit LE - nRF52832

#define  FICR_INFO_PART  0x10000100  //PartCode address of Factory information configuration registers
#define  FICR_MODEL      0x52832     //nRF52832
#define  COEF_BATT       0.00493242  // =*3.60/1024.0*1.403(divider 806k+2M ohm)

// SW Matrix GPIO assign

#define ROW1 28  //GPIO28
#define ROW2 29  //GPIO29
#define ROW3 12  //GPIO12
#define ROW4 13  //GPIO13
#define ROW5 14  //GPIO14

#define COL1 20  //GPIO20
#define COL2 25  //GPIO25
#define COL3 26  //GPIO26
#define COL4 27  //GPIO27
#define COL5 30  //GPIO30

// Rotary Encorder GPIO assign

#define RE1_A    15  //GPIO15 for Rotary Encorder 1-A
#define RE1_B    16  //GPIO16 for Rotary Encorder 1-B
#define RE2_A     7  //GPIO7  for Rotary Encorder 2-A
#define RE2_B    11  //GPIO11 for Rotary Encorder 2-B

// Analog Ports assign

#define XAXIS    A0  //Analog0 for Joystick X-axis
#define YAXIS    A1  //Analog1 for Joystick Y-axis
#define ZAXIS    A2  //Analog2 for Volume resistor
#define SLIDER   A3  //Analog3 for Slide Volume
#define BATT     A7  //Analog7 for Battery Voltage (divider 806k+2M ohm)

// On Board Blue LED port

#define BLULED   19  //GPIO19
